proc FullFName FName {
    if {[string index $FName 0] == "/"} {
	return $FName
    } else {
	return [exec pwd]/$FName
    }
}


proc PnmSize FName {
    set Resol [exec pnmfile $FName]
    return "[lindex $Resol 3] [lindex $Resol 5]"
}


foreach File $argv {
    puts stderr "Working on file $File"
    set BaseFName [lindex [split $File "."] 0]
    set Resol [PnmSize $File]
    set xsize [lindex $Resol 0]
    set ysize [lindex $Resol 1]
    puts "set PicWidth $xsize"
    puts "set PicHeight $ysize"
    puts "set PiecesList \{ \\"
    set gcf $xsize
    while {$gcf != 0 && ([expr $xsize%$gcf] != 0 || [expr $ysize%$gcf] != 0 || [expr $xsize/$gcf] < 5 || [expr $ysize/$gcf] < 5)} {incr gcf -1}
    if {$gcf > 50} {
	puts stderr "Using square pieces of size $gcf."
	set pwidth $gcf
	set pheight $gcf
    } else {
	for {set i [expr $xsize/70]} {[expr $xsize%$i] != 0} {incr i} {}
	set pwidth [expr $xsize/$i]
	for {set i [expr $ysize/70]} {[expr $ysize%$i] != 0} {incr i} {}
	set pheight [expr $ysize/$i]
	puts stderr "Unable to find square pieces.  Using pieces of size $pwidth by $pheight."
    }

    for {set thisx 0} {$thisx <= [expr $xsize-$pwidth]} {incr thisx $pwidth} {
	for {set thisy 0} {$thisy <= [expr $ysize-$pheight]} {incr thisy $pheight} {
	    set CutBaseName $BaseFName.$thisx-$thisy-$pwidth-$pheight
	    puts -nonewline "          \{\{$thisx $thisy\} \{"
	    exec /home/grads/share/pbmplus/bin.sun4/pnmcut $thisx $thisy $pwidth $pheight $File > $CutBaseName.pnm
	    exec pnmflip -r270 $CutBaseName.pnm > ${CutBaseName}-2.pnm
	    exec pnmflip -r180 $CutBaseName.pnm > ${CutBaseName}-3.pnm
	    exec pnmflip -r90  $CutBaseName.pnm > ${CutBaseName}-4.pnm
	    exec mv $CutBaseName.pnm ${CutBaseName}-1.pnm
	    foreach Rot {1 2 3 4} {
		puts -nonewline "${CutBaseName}-$Rot.xbm "
		exec rsh ii ~jungle/iris/bin/imconv -infile [FullFName ${CutBaseName}-$Rot.pnm] -outfile [FullFName ${CutBaseName}-$Rot.xbm] < /dev/null &
	    }
	    puts "\}\} \\"
	}
    }
    puts "          \}"
}

exit 0
