proc DistributeVar VarName {
#    puts "DistributeVar: Creating lock for $VarName."
    CreateLock $VarName
    global [ArrayName $VarName]
    gk_toAll RemoteCreateDistribVar $VarName [set $VarName]
}


trace variable gk_entrantUserNum w DistribNewUser
proc DistribNewUser args {
#    puts "DistribNewUser: Adding new user."

    global gk_entrantUserNum
    global TentVals
    if {[info exists TentVals] == 0} return
#    puts "DistribNewUser: Updating new user."
    foreach Name [array names TentVals] {
	global [ArrayName $Name]
	gk_toUserNum $gk_entrantUserNum RemoteCreateDistribVar $Name [set $Name]
    }
#    puts "DistribNewUser: Done."
}


set NewDistribVar ""
proc RemoteCreateDistribVar {VarName VarVal} {
#    puts "RemoteCreateDistribVar: Setting TentVals($VarName)"
    global NewDistribVar
    set NewDistribVar $VarName
    global [ArrayName $VarName]
    set $VarName $VarVal

    global TentVals
    set TentVals($VarName) ""
#    puts "RemoteCreateDistribVar:"
}


proc GrabVar VarName {
#    puts "GrabVar:"
    global TentVals
    global [ArrayName $VarName]
    set TentVal($VarName) [set $VarName]
    
    global LockStates
    trace variable LockStates($VarName) w DistribStateChange
    GrabLock $VarName
}


proc ReleaseVar VarName {
    ReleaseLock $VarName
}


proc DistribStateChange {Array LockName args} {
    global LockStates
    global [ArrayName $LockName]

#    puts stdout "DistribStateChange: $LockName became $LockStates($LockName)"
    if {$LockStates($LockName) == "Tentative"} {
	global TentVals
	set TentVals($LockName) [set $LockName]
    }

    if {$LockStates($LockName) == "Approved"} {
#	puts stdout "DistribStateChange: Lock became approved."
	VarChange $LockName
	trace variable $LockName w VarChangeTrace
    }

    if {$LockStates($LockName) == "Released"} {
#	puts stdout "DistribStateChange: Lock became released"
	VarChange $LockName
	trace vdelete LockStates($LockName) w DistribStateChange
	trace vdelete $LockName w VarChangeTrace
    }

    if {$LockStates($LockName) == "Denied"} {
#	puts stdout "DistribStateChange: Lock became denied"
	global TentVals
#	puts "Reseting value of $LockName to $TentVals($LockName)"
	trace vdelete LockStates($LockName) w DistribStateChange
	trace vdelete $LockName w VarChangeTrace
	
	global LockLayerName
	if {$LockLayerName == "semi-optimistic"} {set $LockName $TentVals($LockName)}
    } 

#    puts stdout "DistribStateChange: Done."
}

proc VarChangeTrace {ArrayName IndexName args} {
    if {$IndexName == ""} {VarChange $ArrayName
    } else {VarChange ${ArrayName}(${IndexName})}
}

proc VarChange VarName {
#    puts stdout "VarChange: $VarName changed."
    global LockStates
    if {$LockStates($VarName) == "Approved"} {
	global [ArrayName $VarName]
	global _gk_remoteUsers
	set NewVal [set $VarName]
	gk_toOthers SetDistribVar $VarName $NewVal
    }
#    puts stdout "VarChange: Done"
}


proc SetDistribVar {VarName NewVal} {
#    puts "SetDistribVar: new value of $VarName is $NewVal"
    global [ArrayName $VarName]
    set $VarName $NewVal
}


proc ArrayName VarName {
    return [lindex [split $VarName "("] 0];
}
