# 
# ShowLockWithCursor automatically changes the cursor with a canvas
# when a lock changes.  Multiple locks can be associated with the same
# canvas, and multiple canvases can be associated with the same lock.
# LockName is the name of an existing lock.  Canvas is the canvas over
# which to change the cursor.  Cursors is a keyed list where the keys
# are the states of the lock and the values are the name of the cursor
# to use.  Cursors defaults to some good cursors.
# 
proc ShowLockWithCursor {LockName Canvas {Cursors {{Tentative question_arrow} {Approved arrow} {Released {}} {Denied {}}}}} {
    global CursorWatches
    set Canvas [join [split $Canvas "."]]
    set FieldName $LockName.$Canvas
#    puts "FieldName = $FieldName"
    if {$Cursors == ""} {keyldel CursorWatches $FieldName}
    keylset CursorWatches $FieldName $Cursors

    global LockStates
    trace variable LockStates($LockName) w CursorStateChange
}


proc CursorStateChange {Array LockName ops} {
    global CursorWatches
    set CanvasKeyed [keylget CursorWatches $LockName]
    foreach Canvas [keylkeys CanvasKeyed] {
	global LockStates
	set CursorList [keylget CanvasKeyed $Canvas]
	set Cursor [keylget CursorList $LockStates($LockName)]
	set Canvas [join [split $Canvas " "] "."]
	$Canvas config -cursor $Cursor
    }
}

# 
# There should be a way to undo a ShowLockWithCursor.
# 
