#
# Front end to the NetFone program.
#
# Assumes the "speaker" program is already running on the machines, and
# starts and stops the "mike" program.
#
# Let's you talk over the speakers!


gk_initConf $argv

set tmpfile /tmp/zcdsfsdfd
set connectionStarted 0

proc dophone args {   global connectionStarted _gk_remoteUsers
    if {$connectionStarted == 0} {
	set connectionStarted 1
	set user [lindex $_gk_remoteUsers 0]
	set name [keylget user username]
	set i [keylget user usernum]
	toplevel .phone
	frame .phone.f
	pack append .phone.f \
	    [label .phone.f.lbl -text [concat "Calling " $name]] top \
	    [button .phone.f.b1 -text Call -command "startit $i"] left 
	pack append .phone .phone.f {top expand fill}
    }
}

proc startit {usernum} {  global _gk_localUser
    set user [_gk_findUser $usernum]
    RDO [keylget user filedesc] reqAcceptCall [keylget _gk_localUser usernum]
    .phone.f.b1 configure -state disabled
}

proc connectCall {usernum} {   
    destroy .phone
    makeConnection $usernum
}

proc makeConnection {usernum} { global pid tmpfile gk_library
    set user [_gk_findUser $usernum]
    set targethost [keylget user reghost]
    set name [keylget user userid]
    exec sed s/HOST/$targethost/g < $gk_library/confs/netfone/mike.csh > $tmpfile
    exec chmod +x $tmpfile
    set fid [eval "open \{|$tmpfile\} r"]
    after 1000 "exec rm $tmpfile"
    set pid [lindex [gets $fid] 1]
    toplevel .callstatus
    frame .callstatus.f
    pack append .callstatus.f \
	[message .callstatus.f.msg -text [concat "Connected to " $name]] top \
	[button .callstatus.f.hangup -text Hangup -command "hangup $usernum"] { top expand fill }
    pack append .callstatus .callstatus.f top
}

proc stopit {} {   global pid
    exec kill -9 $pid
    destroy .phone
}

proc callRejected {usernum} {
    destroy .phone
}

proc reqAcceptCall {usernum} { global _gk_remoteUsers 
    toplevel .acceptdlg
    frame .acceptdlg.f
    set user [_gk_findUser $usernum]
    set name [keylget user userid]
    message .acceptdlg.f.msg \
	-text [concat "Incoming call from " $name]
    button .acceptdlg.f.pickup -text Pickup -command "pickupCall $usernum"
    button .acceptdlg.f.reject -text Reject -command "rejectCall $usernum"
    pack append .acceptdlg.f \
	.acceptdlg.f.msg top \
	.acceptdlg.f.pickup left \
	.acceptdlg.f.reject left
    pack append .acceptdlg .acceptdlg.f top
}

proc pickupCall {usernum} {  global _gk_localUser
    set user [_gk_findUser $usernum]
    RDO [keylget user filedesc] connectCall [keylget _gk_localUser usernum]
    destroy .acceptdlg
    makeConnection $usernum
}

proc rejectCall {usernum} { global _gk_localUser
    set user [_gk_findUser $usernum]
    RDO [keylget user filedesc] callRejected [keylget _gk_localUser usernum]
    destroy .acceptdlg
}

proc hangup {usernum} {  global _gk_localUser
    set user [_gk_findUser $usernum]
    RDO [keylget user filedesc] do_hangup [keylget _gk_localUser usernum]
    do_hangup $usernum
}

proc do_hangup {usernum} {  global pid
    exec kill -9 $pid
    destroy .
}
trace variable gk_newUser w dophone

set rhst [keylget _gk_localUser reghost]
set rprt [keylget _gk_localUser regport]
set myid $rhst$rprt
wm withdraw .
if {$myid!=[keylget _gk_localUser originator]} {
    set connectionStarted 1
}
