# Simple Brainstorm Conference Application
# ---------------------------------
#
# This program is a very simple anonymous group brainstorming tool, where
# users can enter an "idea" and it will appear on all users' screens.  To
# be practical it needs routines to e.g. save the ideas to a file.

# Initialize conference
gk_initConf $argv

# Get default pulldown menu bar and call it .menu
gk_defaultMenu .menu

# Make listbox called .list and frame (.f) for entry box (.entry)
# and button (.b)
listbox .list -geometry 40x16 -background LightSteelBlue
frame .f -background LightSteelBlue
entry .f.entry -textvariable myIdea -relief sunken -width 30
button .f.b -text Enter -command { put_entry_in_list }

# Pack .entry and .b into .f, and then .f into the main window.
pack append .f .f.entry left .f.b {left}
pack append . .f {bottom fill expand}

# Pack pulldown menu, listbox and frame into main.  Bind proc
# to carriage return.
pack append . .menu {top fillx} .list {left fillx}
bind .f.entry <Return> "put_entry_in_list"
bind .list <Return> "put_entry_in_list"

# When the new idea should be entered, put it in the local list and then
# tell everyone else about it
proc put_entry_in_list {} { global myIdea
    if {$myIdea != ""} {
        gk_toAll .list insert end $myIdea
        set myIdea ""
    }
}

